﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win;

namespace PopupProblem {
  public partial class Form1 : Form {
    private bool SuspendAutoCloseUpBeforeOpeningForm;

    public Form1() {
      InitializeComponent();
    }

    private void DropDownPanel(Control sender) {
      var location = PointToScreen(sender.Location);
      location.Offset(0, sender.Size.Height);
      DropDownManager.DropDown(this, pnlDropDown, null, null, Rectangle.Empty, pnlDropDown.Size, location, false);
    }

    private void ShowForm() {
      if (SuspendAutoCloseUpBeforeOpeningForm)
        DropDownManager.SuspendAutoCloseUp();

      var frm = new PopupForm();
      frm.ShowDialog(this);

      if (SuspendAutoCloseUpBeforeOpeningForm)
        DropDownManager.ResumeAutoCloseUp();
    }

    private void btnDropDown_Click(object sender, EventArgs e) {
      SuspendAutoCloseUpBeforeOpeningForm = false;
      DropDownPanel(sender as Control);
    }

    private void btnDropDownSuspend_Click(object sender, EventArgs e) {
      SuspendAutoCloseUpBeforeOpeningForm = true;
      DropDownPanel(sender as Control);
    }

    private void btnShowForm_Click(object sender, EventArgs e) {
      ShowForm();
    }
  }
}
